import { RecoilRoot } from 'recoil'
import { SchemaBuilder } from './components/SchemaBuilder'
import { GameSystemEditor } from './components/GameSystemEditor'
import RecoilizeDebugger from 'recoilize';
import { BrowserRouter, Route, Routes } from 'react-router-dom';
import { SchemaList } from './components/schemalist';

function App() {
  return (
    <RecoilRoot>
      <BrowserRouter>
        <Routes>
          <Route Component={SchemaList} path='/schemas' />
          <Route Component={SchemaBuilder} path='/schema/:id' />
          {/* <Route Component={SchemaBuilder} path='/schema/new' /> */}
          <Route Component={GameSystemEditor} path='/game-system/:id' />
          {/* <Route Component={GameSystemEditor} path='/game-system/new' /> */}
        </Routes>
      </BrowserRouter>
      <RecoilizeDebugger />
    </RecoilRoot>
  )
}

export default App
