import { useRecoilValue } from 'recoil';
import { SchemaEditAtom } from '../../recoil/atoms/schema';
import { FCC } from '../../types'
import { InputBinder } from '../../types/inputBinder'
import { TEMPLATE_TYPES } from '../../constants/TemplateTypes';

interface IProps {
  bind: InputBinder
}

export const FieldTypeInput: FCC<IProps> = ({ bind }) => {
  const schema = useRecoilValue(SchemaEditAtom);

  return (
    <label className="w-min">
      Type:
      <input type="text" {...bind} list="type-editor-type-list" />
      <datalist id="type-editor-type-list">
        {Object.keys(TEMPLATE_TYPES).map(k => (
          <option className="capitalize" value={k}>{k}</option>
        ))}
        {Object.keys(schema.types).map(k => (
          <option className="capitalize" value={k}>{k}</option>
        ))}
      </datalist>
    </label>
  )
}