import { FC, useEffect, useState } from "react";
import { GameSystemsService } from "../services/game-systems";
import { Link } from "react-router-dom";

export const SchemaList: FC = () => {
  const [schemas, setSchemas] = useState<[string,string][]>([]);
  useEffect(() => {
    GameSystemsService.getSchemaList().then(l => {
      setSchemas(l)
    });
  }, [])
  return (
    <div className="container pt-12 flex flex-col gap-6">
      <Link to="/schema/new"><button>New Schema</button></Link>
      <ul className="panel">
        {schemas.map(([id,name])=> <li key={id}><Link to={'/schema/' + id}><span className="w-full">{name || 'Unnamed Schema'}</span></Link></li>)}
      </ul>
    </div>
  )
}