import { GameSystem } from "../types/gameSystem";
import { Schema } from "../types/schema";
import { idb } from "./indexeddb";

const emptySchema = {
  name: "",
  types: {},
  templates: {},
  id: crypto.randomUUID(),
};

export const GameSystemsService = {
  // todo - connect to service to save schema for game
  saveSchema: async (schema: Schema) => {
    // localStorage.setItem('schema ' + schema.id, JSON.stringify(schema));
    try {
      return await idb.createOrUpdate({
        storeName: "schema",
        ...schema,
      });
    } catch (e) {
      console.log(e);
    }
  },
  // todo - connect to service to fetch schema for game
  getSchema: async (
    id: string,
  ): Promise<Schema> => {
    try {
      const schema = await idb.read("schema", id);
      return schema;
    } catch (e) {
      throw e;
    }
  },
  getSchemaList: async () => await idb.listAll<string>("schema", "name"),

  saveGameSystem: async (gs: GameSystem) => {
    localStorage.setItem("game-system " + gs.id, JSON.stringify(gs));
    return { status: 200 };
  },
  getGameSystem: async (
    id: string,
  ): Promise<GameSystem> => await idb.read("game-system", id),
};
