export class QueryParams {
  private params = new Map<string, string>()
  constructor(options?: {clean: boolean}) {
    if (!options?.clean) {
      const {search} = location;
      for (const [key, value] of search.replace('?', '').split('&').map(e => e.split('='))) {
        this.params.set(key, value);
      }
    }
  }

  get = this.params.get
  set = this.params.set
  delete = this.params.delete
  clear = this.params.clear
  
  apply() {
    location.search = '?' + encodeURIComponent(Array.from(this.params.entries()).map(e => e.join('=')).join('&'))
  }
}